<template>
  <div  class="container-fluid">
    <div 
      @mousemove="mouseM"
      @mousedown.middle.prevent.stop="save" 
      @mousewheel.up="changeDown"
      @mousedown.left="drawFlagOn" 
      @mouseup.left="drawFlagOff" 
      @contextmenu.prevent.stop=""
      @click.right.stop.prevent="clearPods" 
      id="home-animation" ></div>
  </div>
</template>

<script>

import { SVG } from '@svgdotjs/svg.js'
import { saveAs } from 'file-saver';
import { Color } from '@svgdotjs/svg.js'

export default {
  name: 'home',
  props: {
  edev: Array,
  emkt: Array,
  tagline: String,
  },
  created: function (){

  },
  mounted: function (){
  this.draw = SVG().addTo('#home-animation')
  this.draw.viewbox(0,0,window.innerWidth,window.innerWidth)

  },
  data: function () {

  return {
  should_draw: false,
  tolerance_stop:0.01,
  last_x:0,
  last_y:0,
  pods: [],
  color: Color
  }

  },
  methods: {

    changeDown: function(e){
      this.r = Math.round(Math.random()*255)
      this.g = Math.round(Math.random()*255)
      this.b = Math.round(Math.random()*255)
      this.r = this.r + Math.round(e.deltaY*0.5)
      this.g = this.g + Math.round(e.deltaY*0.5)
      this.b = this.b + Math.round(e.deltaY*0.5)
      this.color = new Color({r:this.r,g:this.g,b:this.b})
      console.log(this.color)
    },
    save: function() {
      var content = this.draw.svg()

      var blob = new File([content], {type: "image/svg+xml;charset=utf-8"});
      saveAs(blob, "export.svg");

    },
    drawFlagOn: function (){
      this.should_draw = true
      this.pods.push([])
    },
    drawFlagOff: function (){
      this.should_draw = false
    },
    mouseM: function (e){
      if (this.should_draw){
        var pod = this.draw.circle(30)
        pod.attr("fill",this.color)
        //var wx = window.innerWidth
        //var wy = window.innerHeight
        var x = e.clientX
        var y = e.clientY
        var deltax = (this.last_x - x)
        if (deltax <= 0){
            deltax *= -1
        }

        var deltay = (this.last_y - y)
        if (deltay <= 0){
            deltay *= -1
        }
        
        pod.attr('cx',x)
        pod.attr('cy',y)
        //console.log(x)
        //console.log(y)
        this.last_x = x
        this.last_y = y
        
        var last_index = this.pods.length-1
        this.pods[last_index].push(pod)
      }
    },
    clearPods: function () {
    //for(var i = this.pods.length-1; i >= 0; i--){
      var poped = this.pods.pop()
      for(var j = 0; j < poped.length; j++){
          var pod = poped[poped.length-1-j]
          pod.animate(100).delay(j*3).attr({"fill-opacity":0.0}).after(function(){
             pod.remove()
          })
         
      
      }
    //}
    }
  }

}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
  #home-animation{
    height: 100vh;
    width: 100%;
    background: transparent;
  }

  #home-animation>svg{
    height: 100vh;
    width: 100%;
    background: transparent;
  }

</style>
